MCFj_conf2= function(xcov,s,w,tvalues,pivalues,betavalues,hvalues,Nstates,Nbeta,Nabs,x,type,lim){
  
  #This calculates credibility intervals for a sample obtained
  t=seq(0,s,w)
  Alist = c(0)
  Plist = c(0)
  
  v_type=rep(0,Nabs)
  v_type[type]=1
  if(full==TRUE){
    v_type=rep(1,Nabs)
  }
  
  a=100
  conflist_low=c(0)
  conflist_high=c(0)
  fvalues=matrix(0,nrow=(length(tvalues)/a),ncol=length(t))
  for(i in 1:length(t)){
    n=1
    for(k in 1:length(tvalues)){
      if(((k%%a)==0)){
        Atemp=matrix(0,nrow=Nstates,ncol=Nstates) 
        L = t(t(tvalues[[k]])*exp(as.double(xcov%*%(t(t(betavalues[[k]]))))))
        Atemp[1:(Nstates-Nabs),1:(Nstates-Nabs)]=hvalues[[k]]
        Atemp[1:(Nstates-Nabs),(Nstates-Nabs+1):Nstates] = L
        Q = hvalues[[k]]-diag(rowSums(Atemp[1:(Nstates-Nabs),1:Nstates]))
        Qinv=solve(Q)
        flist = pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type
        fvalues[n,i] = flist
        n=n+1
      }
      
    }
    print(i)
    confint_low=sort(fvalues[,i])[ceiling((length(tvalues)/a)*0.025)]
    confint_high=sort(fvalues[,i])[floor((length(tvalues)/a)*0.975)]
    conflist_low[i]=confint_low
    conflist_high[i]=confint_high 
  }
  n=1
  for(k in 1:length(tvalues)){
    if(((k%%a)==0)){
      if(k!=a){
        par(new = TRUE)
      }
      plot(t,fvalues[n,],col = 'red',type = 'l',lty = 1,xlab ='',ylab='', ylim=c(0,lim))
      n=n+1
    }
  }



  meanlist=rep(0,length(t))
  counter=0
  for(k in 1:length(tvalues)){
    if(((k%%(a))==0)){
      Atemp=matrix(0,nrow=Nstates,ncol=Nstates) 
      L = t(t(tvalues[[k]])*exp(as.double(xcov%*%(t(t(betavalues[[k]]))))))
      Atemp[1:(Nstates-Nabs),1:(Nstates-Nabs)]=hvalues[[k]]
      Atemp[1:(Nstates-Nabs),(Nstates-Nabs+1):Nstates] = L
      Q = (hvalues[[k]]-diag(diag(hvalues[[k]])))-diag(rowSums(Atemp[1:(Nstates-Nabs),1:Nstates]))
      Qinv=solve(Q)
      for(i in 1:length(t)){
        #subdens
        meanlist[i] = meanlist[i]+pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type
        #subhaz
#         meanlist[i] = meanlist[i] + pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type/(1-pivalues[[k]]%*%Qinv%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%rep(1,Nabs))
        #subdistr
#             meanlist[i] = meanlist[i]+pivalues[[k]]%*%Qinv%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%v_type
      
      }
      print(k)
      counter=counter+1
    }
  }
  meanlist=meanlist/counter
  lines(t,meanlist,col='blue',lty = 1,lwd=3)
  lines(t,conflist_low,col='black',lty = 1,lwd=3)
  lines(t,conflist_high,col='black',lty = 1,lwd=3, xlab='t',ylab='Sub-hazard')
legend('top',legend = c('Posterior mean','Confidence limits','Posterior estimates'),col = c('blue','black','red'),lty = c(1,1,1),lwd=c(3,3,1),bty = 'n')
legend('topright',legend = c('Cause',type),horiz=TRUE,bty = 'n')

}