SimulateMarkov = function(x,c,A,Nstates,Nabs,pi){
  j = 0
  t = 0
  iterations = 0
  while(!((j == c) && (t>=x))){
   t_xj = NA
   laststate = NA
   B_temp = rep(0,(Nstates-Nabs))
   Z_temp = rep(0,(Nstates-Nabs))
   N_temp = matrix(0,nrow = Nstates,ncol=Nstates)
   
   initial = sample(1:(Nstates-Nabs),1,replace=T,prob = pi)
   j = initial
   
   t = 0
   B_temp[j] = B_temp[j] + 1
   while(j < (Nstates-Nabs + 1)){
     
    told = t
    t = t + rexp(1,rate = -A[j,j])
    
    if(t<x){
      Z_temp[j] = Z_temp[j] + (t-told) 
    }
    if((told<x) && (t>=x)){
      t_xj=A[j,c]
      laststate = j
      Z_temp[j] = Z_temp[j] + (x-told)
    }
    
    p = A[j,]
    p[j] = 0
    p = p/(-A[j,j])
    
    jold = j
    j = sample(1:Nstates,1, replace=T, prob=p)
    
    if(t<x){
      N_temp[jold,j] = N_temp[jold,j] + 1
    }
    if((t>=x)&&(told<x)){
      N_temp[jold,c] = N_temp[jold,c] + 1
    }
   }
  }
  output = list(B_temp,N_temp,Z_temp,t_xj,laststate)
}