posteriormean= function(s,w,tvalues,pivalues,A,Api,Nstates,Astates,Nabs,Q1,L1,x,type,ylimit){
  
  
  t = seq(0,s,w)

  v_type=rep(0,Nabs)
  v_type[type]=1

  Alist=c(0)
  mean=rep(0,length(t))

  Q1inv=solve(Q1)
  for(k in 1:length(tvalues)){
      flist = c(0)
      Q = genQLp(tvalues[[k]],Nstates,Nabs)[[1]]
      L = genQLp(tvalues[[k]],Nstates,Nabs)[[2]]
      Qinv = solve(Q)
      for(i in 1:length(t)){
#               flist[i] = pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type
#               flist[i] = pivalues[[k]]%*%Qinv%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%v_type
              flist[i] = pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type/(1-pivalues[[k]]%*%solve(Q)%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%rep(1,Nabs))
              mean[i] = mean[i]+flist[i]

#               Alist[i] = Api%*%(MatrixExp(t[i]*Q1))%*%L1%*%v_type
#               Alist[i] = Api%*%Q1inv%*%(MatrixExp(t[i]*Q1)-diag(Astates-Nabs))%*%L1%*%v_type
              Alist[i] = Api%*%(MatrixExp(t[i]*Q1))%*%L1%*%v_type/(1-Api%*%Q1inv%*%(MatrixExp(t[i]*Q1)-diag(Astates-Nabs))%*%L1%*%rep(1,Nabs))
      }
      print(k)
  }
  mean = mean/(length(tvalues))

# Non-parametric estimate, specific cause to be analyzed must be changed within this function
#   CumIncidence(group=type,ftime=x[,1],fstatus=x[,2], cencode = Nstates-Nabs, t=t)
#   par(new = TRUE)

  plot(t,Alist,col = 'red',type = 'l',lty = 1,lwd=2,xlab ='',ylab='', ylim = c(0,ylimit))
  lines(t,mean,col = 'blue',type = 'l',lty = 2,lwd=2,xlab ='',ylab='', ylim = c(0,ylimit))

# legend('topleft',legend = c('Posterior mean','Empirical estimate','True function'),col = c('blue','black','red'),lty = c(2,1,1),lwd=c(1,1,2),bty = 'n')
legend('topleft',legend = c('Posterior mean','Theoretical function'),col = c('blue','red'),lty = c(2,1),lwd=c(2,2),bty = 'n')
}
