SimulateFailures_cens=function(m,A,Astates,Nabs,Api){
#This function simulates censored Phase-type data

  x = matrix(0,nrow = m,ncol = 3)
  for(i in 1:m){
     initial = sample(1:(Astates-Nabs),1,replace=T,prob = Api)
     j = initial
     while(j < (Astates-Nabs + 1)){
       x[i,1] = x[i,1] + rexp(1,rate = -A[j,j])
       p = A[j,]
       p[j] = 0
       p = p/(-A[j,j])
       j = sample(1:Astates,1,replace=T, prob=p)
     }
     C = rweibull(1,scale = 5,shape = 1.5)
     if(C<x[i,1]){
       x[i,1] = C
       x[i,3] = 1
       x[i,2] = Astates-Nabs
     }
     else{
       x[i,3] = 0
       x[i,2] = j
     }
  }
  print(sum(x[,3])/length(x[,1]))
  x
}
