analysis= function(xcov,s,w,a,tvalues,pivalues,betavalues,hvalues,Api,AH,AL,beta,Nstates,Astates,Nabs,x,Nbeta,type,ylimit){
  
  #Time vector
  t=seq(0,s,w)

   
  #Initializing
  Alist = c(0)
  flist = c(0)
  mean=rep(0,length(t))

  
  #Calcuating simulated Phase-type parameters, take away if weibull, it will crash method
  Hdiag=c(0)
  A=matrix(0,nrow=(length(AH[1,])+length(L[1,])),ncol=(length(AH[1,])+length(AL[1,])))
  temp=(exp(as.double(xcov%*%t(t(beta)))))
  A[1:length(AH[1,]),(1+length(AH[1,])):length(A[1,])]=t(t(AL)*temp)
  for(i in 1:(Astates-Nabs)){
     Hdiag[i]= -((sum(AH[i,])-AH[i,i])+sum(AL[i,]*exp(as.double(xcov%*%t(t(beta))))))
  }
  A[1:length(AH[1,]),1:length(AH[1,])] = (AH-diag(diag(AH)))+diag(Hdiag)
  QA=genQLp(A,Astates,Nabs)[[1]]
  LA=genQLp(A,Astates,Nabs)[[2]]
  QAinv=solve(QA)
  

  #Calculating mean parameter values
  hmean=matrix(0,nrow=(Nstates-Nabs),ncol=(Nstates-Nabs))
  tmean=matrix(0,nrow=(Nstates-Nabs),ncol=(Nabs))
  pimean=rep(0,(Nstates-Nabs))
  betamean=rep(0,Nbeta)

  counter=0
  for(k in 1:length(tvalues)){
    if(((k%%a)==0) || (k==1)){
      hmean=hmean+hvalues[[k]]
      tmean=tmean+tvalues[[k]]
      betamean=betamean+betavalues[[k]]
      pimean=pimean+pivalues[[k]]
      counter=counter+1
    }
  }
  hmean=hmean/counter
  tmean=tmean/counter
  pimean=pimean/counter
  betamean=betamean/counter

  #Estimating standard deviation of beta-values 
  counter=0
  betadev=matrix(0,nrow=Nbeta,ncol=Nabs)
  for(k in 1:length(tvalues)){
    if(((k%%a)==0) || (k==1)){
      betadev=betadev+(betavalues[[k]]-betamean)^2
      counter=counter+1
    }
  }
  betadev=sqrt(betadev/(counter-1))
  
  v_type=rep(0,Nabs)
  v_type[type]=1
  

#Calculations for Weibull-model used in the report
#   if(type==1){
#      Afunc=function(t){(1-pweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,2]))))))*dweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,1])))))}
#      Afunc1=function(t){(1-pweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,1]))))))*dweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,2])))))}
#   }
#   else{
#     Afunc=function(t){(1-pweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,1]))))))*dweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,2])))))}
#     Afunc1=function(t){(1-pweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,2]))))))*dweibull(t,shape=2,scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,1])))))}
#   }


  for(i in 1:length(t)){
      #Phase-type simulated
    
      #sub-density
#       Alist[i] = Api%*%(MatrixExp(t[i]*QA))%*%LA%*%v_type
      #sub-distribution
      Alist[i] = Api%*%QAinv%*%(MatrixExp(t[i]*QA)-diag(Astates-Nabs))%*%LA%*%v_type
      #sub-hazard
#       Alist[i] = Api%*%(MatrixExp(t[i]*QA))%*%LA%*%v_type/(1-Api%*%QAinv%*%(MatrixExp(t[i]*QA)-diag(Astates-Nabs))%*%LA%*%rep(1,Nabs))
      
      
      #Weibull simulated
      
      #Hazard rate
      #Alist[i]=mvec[type]*pweibull(t[i],scale=sqrt(2)*exp(as.double(-0.5*xcov%*%t(t(beta[,type])))),shape=2)
      
      #sub-distribution
#       Alist[i]=integrate(Afunc,0,t[i])$value

  }
  counter=0
  for(k in 1:length(tvalues)){
    if(((k%%a)==0) || (k==1)){
      Atemp=matrix(0,nrow=Nstates,ncol=Nstates) 
      L = t(t(tvalues[[k]])*exp(as.double(xcov%*%(t(t(betavalues[[k]]))))))
      Atemp[1:(Nstates-Nabs),1:(Nstates-Nabs)]=hvalues[[k]]
      Atemp[1:(Nstates-Nabs),(Nstates-Nabs+1):Nstates] = L
      Q = (hvalues[[k]]-diag(diag(hvalues[[k]])))-diag(rowSums(Atemp[1:(Nstates-Nabs),1:Nstates]))
 
      Qinv = solve(Q)
      for(i in 1:length(t)){
        
        
        #Phase-type estimate
        
        #sub-density
#         flist[i] = pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%v_type
        
        #sub-distribution
        flist[i] = pivalues[[k]]%*%Qinv%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%v_type
        
        #sub-hazard
#         flist[i] = pivalues[[k]]%*%(MatrixExp(t[i]*Q))%*%L%*%(t(t(v_type)))/(1-pivalues[[k]]%*%Qinv%*%(MatrixExp(t[i]*Q)-diag(Nstates-Nabs))%*%L%*%rep(1,Nabs))
        
        
        mean[i] = mean[i]+flist[i]
      }
#       print(k)
      counter=counter+1
    }
  }
  mean=mean/counter

    #timereg analysis, saves everything in out, which can be plotted if necessary
#     xdata=as.data.frame(x)
#     add1=comp.risk(Hist(x[,1],x[,2]-(Nstates-Nabs),cens.code=0)~const(V4)+const(V5),data=xdata,cause=type,model='prop',cens.model="cox")
#     newdata=data.frame(V4=xcov[1],V5=xcov[2])
#     out<-predict(add1,newdata=newdata)


    #cmprsk analysis, pred can be plotted
    betaestimates=crr(ftime=x[,1],fstatus=x[,2]-(Nstates-Nabs), cov1=x[,4:(4+Nbeta-1)],failcode=type,cencode=0)
    pred=predict(betaestimates,cov1=xcov)

     #This is only for sub-distributions, use par if out or pred are plotted
#      plot(pred,ylim=c(0,ylimit),xlim=c(0,s),xlab='t',ylab='Probability')
#      par(new = TRUE)
#      plot(out, multiple = 1, se = 0, uniform = 0, col = 1,lty=3,ylim=c(0,ylimit),xlim=c(0,s),xlab='t',ylab='Probability')
#      par(new = TRUE)
     plot(t,mean,col = 'blue',type = 'l',lty = 2,lwd=1,xlab ='',ylab='', ylim = c(0,ylimit))
     lines(t,Alist,col='red',type='l',lty = 1,lwd=2,xlab ='',ylab='', ylim = c(0,1.1))

#      #Use this if non-parametric is not plotted
#      plot(t,mean,col = 'blue',type = 'l',lty = 2,lwd=1,xlab ='',ylab='', ylim = c(0,ylimit))
#      lines(t,Alist,col='red',type='l',lty = 1,lwd=2,xlab ='',ylab='', ylim = c(0,1.1))

    #legend('topleft',legend = c('PT estimate','FG estimate','timereg estimate'),col = c('blue','black','black'),lty = c(2,1,3),lwd=c(2,1,2),bty = 'n')
    legend('topleft',legend = c('PT estimate','True Hazard rate'),col = c('blue','red'),lty = c(2,1),lwd=c(2,2),bty = 'n')
    # legend('topleft',legend = c('PT estimate','FG estimate','timereg estimate','True distribution'),col = c('blue','black','black','red'),lty = c(2,1,3,1),lwd=c(1,1,2,2),bty = 'n')

  legend('topright',legend= c('w =',xcov), horiz=TRUE, bty = 'n')
  print(betamean)
  print(betadev)


}