#Initialization of dimensions and iterations
Astates =10
Nstates=10
Nabs = 3
Aabs = 3
Nbeta = 2
Nfailures= 150
Nburnin = 1000
Nsamples = 1000
Ntune = 1
cstep = 0.01*matrix(1,nrow=Nbeta,ncol=Nabs)
sigma=0.3
#Creating theoretical parameters
A = matrix(0,nrow = Astates,ncol = Astates)


A[1,1] = 0
A[1,2] = 4
A[1,3] = 0.5
A[1,4] = 2
A[1,5]= 1
A[1,6] = 0.1
A[1,7] = 0.4
A[1,8] = 1.2
A[1,9] = 0.1
A[1,10] = 2
A[2,1] = 1
A[2,2] = 0
A[2,3] = 2
A[2,4] = 0.5
A[2,5] = 0.5
A[2,6] = 0.1
A[2,7] = 0.8
A[2,8] = 0.5
A[2,9] = 1
A[2,10] = 3
A[3,1] = 0.3
A[3,2] = 0.1
A[3,3] = 0
A[3,4] = 1
A[3,5] = 0.7
A[3,6] = 2.2
A[3,7] = 3
A[3,8] = 0.0
A[3,9] = 0.2
A[3,10] = 0.6
A[4,1] = 2
A[4,2] = 0.3
A[4,3] = 0.1
A[4,4] = 0
A[4,5] = 3
A[4,6] = 0.2
A[4,7] = 0.1
A[4,8] = 0.9
A[4,9] = 0.5
A[4,10] = 2
A[5,1] = 0.2
A[5,2] = 3
A[5,3] = 0.6
A[5,4] = 0.1
A[5,5] = 0
A[5,6] = 1
A[5,7] = 0.3
A[5,8] = 2
A[5,9] = 0.1
A[5,10] = 2
A[6,1] = 2
A[6,2] = 1
A[6,3] = 0.1
A[6,4] = 0.3
A[6,5] = 0.4
A[6,6] = 0
A[6,7] = 1
A[6,8] = 0.45
A[6,9] = 0.2
A[6,10] = 4
A[7,1] = 2
A[7,2] = 1
A[7,3] = 0.1
A[7,4] = 0.3
A[7,5] = 0.4
A[7,6] = 1
A[7,7] = 0
A[7,8] = 0.45
A[7,9] = 0.2
A[7,10] = 4
A=A-diag(rowSums(A))
A=A*0.1
H=A[1:(Astates-Nabs),1:(Astates-Nabs)]
L=A[1:(Astates-Nabs),(Astates-Nabs+1):Astates]

beta=matrix(0,nrow=Nbeta,ncol=Aabs)
beta[1,1]=1
beta[1,2]=0.3
beta[1,3]=0
beta[2,1]=-0.2
beta[2,2]=-0.7
beta[2,3]=-0.5

Api=c(1,0,0,0,0,0,0)

x=sim(Nfailures,H,L,beta,Nstates,Aabs,Api,Nbeta)
x[,2] = x[,2]+Nstates-Astates

# fol <- read.table("follic.txt", sep = ",", header = TRUE)
# evcens <- as.numeric(fol$resp == "NR" | fol$relsite != "")
# crcens <- as.numeric(fol$resp == "CR" & fol$relsite == "" & fol$stat == 1)
# cause <- ifelse(evcens == 1, 1, ifelse(crcens == 1, 2, 0))
# table(cause)
# stage <- as.numeric(fol$clinstg == 2)
# chemo <- as.numeric(fol$ch == "Y")
# times1 <- sort(unique(fol$dftime[cause == 1]))
# x=matrix(0,nrow=Nfailures,ncol=(3+Nbeta))
# x[,1]=fol$dftime
# x[,2]=cause+Nstates-Nabs
# x[,3]=(1-fol$dfcens)
# x[,4]=fol$age/10
# x[,5]=fol$hgb/10
# x[,6]=stage
# x[,7]=chemo



#Initializing parameters which is to be sampled
h = matrix(0, nrow = Nstates-Nabs, ncol = Nstates-Nabs)
t = matrix(0,nrow=(Nstates-Nabs),ncol=Nabs)
A = matrix(0,nrow = Nstates,ncol = Nstates)
pi = rep(0,Nstates-Nabs)

#Specifying hyper-parameters Nhyp and Bhyp
Nhyp = matrix(0.1,nrow = Nstates,ncol = Nstates)

for(i in 1:(Nstates-Nabs)){
  Nhyp[i,i] = 0
}
for(i in (Nstates-Nabs+1):Nstates){
  Nhyp[,i] = 0.1
}

Nhyp[(Nstates-Nabs+1):Nstates,] = 0


Bhyp = rep(0.1,(Nstates-Nabs))


#Drawing from priors
pi = rdirichlet(1,Bhyp)

c = 1000
d = 10
tau = c(0)

theta = c(0)
Zhyp = c(0)
hdiag=matrix(0,nrow=Nfailures,ncol=(Nstates-Nabs))
for(i in 1:(Nstates-Nabs)){
  tau[i] = 1*10
  theta[i] = rgamma(1,shape = c,scale = 1/d)
  Zhyp[i] = rgamma(1,shape = tau[i],scale = 1/theta[i])
}
print(theta)
print(sum(Zhyp))

beta=matrix(0,nrow=Nbeta,ncol=Nabs)
for(j in 1:Nabs){
 beta[,j] = rnorm(Nbeta,mean=0,sd=sigma)

}

for(i in 1:(Nstates-Nabs)){
  for(j in 1:(Nstates-Nabs)){
    if(i!=j){
       h[i,j] = rgamma(1,shape = Nhyp[i,j],scale = 1/(Zhyp[i]))
    }
  }
}
for(i in 1:(Nstates-Nabs)){
    for(j in 1:Nabs){
        t[i,j] = rgamma(1,shape = Nhyp[i,j+(Nstates-Nabs)],scale = 1/Zhyp[i])
    }
    
    for(data in 1:Nfailures){
      hdiag[data,i]=-((sum(h[i,])-h[i,i])+sum(t[i,]*exp(as.double(x[data,4:(4+Nbeta-1)]%*%t(t(beta))))))
    }
}

priort=t
priorh=h
priorbeta=beta
priorhdiag=hdiag
priorpi=pi




initial = list(0)
for(i in 1:Nfailures){
  A[1:(Nstates-Nabs),1:(Nstates-Nabs)] = (h-diag(diag(h)))+diag(hdiag[i,])
  A[1:(Nstates-Nabs),(Nstates-Nabs+1):Nstates] = t(t(t)*exp(as.double(x[i,4:(Nbeta+3)]%*%t(t(beta)))))
  if(x[i,3]==1){
    initial[[i]] = SimulateMarkov_cens(x[i,1],x[i,2],A,Nstates,Nabs,pi)
  }
  else{
    initial[[i]] = SimulateMarkov(x[i,1],x[i,2],A,Nstates,Nabs,pi)
  }
  print(i)
}


tvalues = list(0)
pivalues = list(0)
betavalues=list(0)
hvalues=list(0)
for(k in 1:(Nburnin+Nsamples)){
  print(k)
  
  #Running Metropolis-Hastings
  Y = MH_cens(x,h,t,hdiag,beta,Ntune,Nstates,Nabs,Nfailures,pi,initial,Nbeta)
  B = Y[[1]]
  Z = Y[[2]]
  N = Y[[3]]
  initial = Y[[5]]
  n=Y[[7]]
  z=Y[[6]]
  
  #Running Gibbs-step
  pi = rdirichlet(1,(Bhyp+B))

  for(i in 1:(Nstates-Nabs)){
      theta[i] = rgamma(1,shape = c+tau[i], scale = 1/(d+Zhyp[i]))
      Zhyp[i] = rgamma(1,shape = (tau[i]+sum(Nhyp[i,])),scale = 1/(theta[i]+sum(h[i,])-h[i,i]+sum(t[i,])))
  }


  beta = betaMH(z,h,x,N,n,Z,Nhyp,Zhyp,pi,B,Bhyp,beta,t,Nbeta,cstep,sigma)
  
  
  for(i in 1:(Nstates-Nabs)){
    h[i,i] = 0
    for(j in 1:(Nstates-Nabs)){
      if(i!=j){
        h[i,j] = rgamma(1,shape = (Nhyp[i,j] + N[i,j]),scale = 1/(Zhyp[i]+Z[i]))
      }
    }
  
    
    for(j_a in 1:Nabs){
      t[i,j_a] = rgamma(1,shape = (Nhyp[i,j_a+(Nstates-Nabs)]+N[i,j_a+(Nstates-Nabs)]),scale = 1/(Zhyp[i]+sum(z[,i]*exp(as.double(x[,4:(4+Nbeta-1)]%*%t(t(beta[,j_a])))))))

      
    }
    
    for(data in 1:Nfailures){
      hdiag[data,i]=-((sum(h[i,])-h[i,i])+sum(t[i,]*exp(as.double(x[data,4:(4+Nbeta-1)]%*%t(t(beta))))))  
    }
  }


  #Generating trace plot value and saving sample
  if(k>Nburnin){
    hvalues[[k-Nburnin]] = h
    tvalues[[k-Nburnin]] = t
    pivalues[[k-Nburnin]] = pi
    betavalues[[k-Nburnin]] = beta
  }
}

Astates=10
A = matrix(0,nrow = Astates,ncol = Astates)

A[1,1] = 0
A[1,2] = 4
A[1,3] = 0.5
A[1,4] = 2
A[1,5]= 1
A[1,6] = 0.1
A[1,7] = 0.4
A[1,8] = 1.2
A[1,9] = 0.1
A[1,10] = 2
A[2,1] = 1
A[2,2] = 0
A[2,3] = 2
A[2,4] = 0.5
A[2,5] = 0.5
A[2,6] = 0.1
A[2,7] = 0.8
A[2,8] = 0.5
A[2,9] = 1
A[2,10] = 3
A[3,1] = 0.3
A[3,2] = 0.1
A[3,3] = 0
A[3,4] = 1
A[3,5] = 0.7
A[3,6] = 2.2
A[3,7] = 3
A[3,8] = 0.0
A[3,9] = 0.2
A[3,10] = 0.6
A[4,1] = 2
A[4,2] = 0.3
A[4,3] = 0.1
A[4,4] = 0
A[4,5] = 3
A[4,6] = 0.2
A[4,7] = 0.1
A[4,8] = 0.9
A[4,9] = 0.5
A[4,10] = 2
A[5,1] = 0.2
A[5,2] = 3
A[5,3] = 0.6
A[5,4] = 0.1
A[5,5] = 0
A[5,6] = 1
A[5,7] = 0.3
A[5,8] = 2
A[5,9] = 0.1
A[5,10] = 2
A[6,1] = 2
A[6,2] = 1
A[6,3] = 0.1
A[6,4] = 0.3
A[6,5] = 0.4
A[6,6] = 0
A[6,7] = 1
A[6,8] = 0.45
A[6,9] = 0.2
A[6,10] = 4
A[7,1] = 2
A[7,2] = 1
A[7,3] = 0.1
A[7,4] = 0.3
A[7,5] = 0.4
A[7,6] = 1
A[7,7] = 0
A[7,8] = 0.45
A[7,9] = 0.2
A[7,10] = 4
A=A-diag(rowSums(A))
A=A*0.1

AH=A[1:(Astates-Nabs),1:(Astates-Nabs)]
AL=A[1:(Astates-Nabs),(Astates-Nabs+1):Astates]

Abeta=matrix(0,nrow=Nbeta,ncol=Aabs)
Abeta[1,1]=1
Abeta[1,2]=0.3
Abeta[1,3]=0
# Abeta[1,4]=-1
Abeta[2,1]=-0.2
Abeta[2,2]=-0.7
Abeta[2,3]=-0.5
# Abeta[2,4]=1
Api=c(1,0,0,0,0,0,0)

analysis(c(0,0),10,0.1,1,tvalues,pivalues,betavalues,hvalues,Api,AH,AL,beta,Nstates,Astates,Nabs,x,Nbeta,1,1)