SimulateMarkov_cens = function(x,c,A,Nstates,Nabs,pi,klist){
  j = 0
  t = 0
  while(t<x){
    B_temp = rep(0,(Nstates-Nabs))
    Z_temp = rep(0,(Nstates-Nabs))
    N_temp = matrix(0,nrow = Nstates,ncol=Nstates)
    
    initial = sample(1:(Nstates-Nabs),1,replace=T,prob = pi)
    j = initial
    
    t=0
    B_temp[j] = B_temp[j] + 1
    while(j<(Nstates-Nabs + 1)){
      told=t
      t = t + rexp(1,rate = -A[j,j])
      
      Z_temp[j] = Z_temp[j] + (t-told)
      
      p = A[j,]
      p[j] = 0
      p = p/(-A[j,j])
      
      jold = j
      j = sample(1:Nstates,1, replace=T, prob=p)
      
      N_temp[jold,j] = N_temp[jold,j] + 1
      
    }
  }
  output = list(B_temp,N_temp,Z_temp)
}